/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
	"fmt"
)

// MysqlTraitSshConfig - struct for MysqlTraitSshConfig
type MysqlTraitSshConfig struct {
	DocumentSshConfigTrait *DocumentSshConfigTrait
}

// DocumentSshConfigTraitAsMysqlTraitSshConfig is a convenience function that returns DocumentSshConfigTrait wrapped in MysqlTraitSshConfig
func DocumentSshConfigTraitAsMysqlTraitSshConfig(v *DocumentSshConfigTrait) MysqlTraitSshConfig {
	return MysqlTraitSshConfig{
		DocumentSshConfigTrait: v,
	}
}

// Unmarshal JSON data into one of the pointers in the struct
func (dst *MysqlTraitSshConfig) UnmarshalJSON(data []byte) error {
	var err error
	// this object is nullable so check if the payload is null or empty string
	if string(data) == "" || string(data) == "{}" {
		return nil
	}

	match := 0
	// try to unmarshal data into DocumentSshConfigTrait
	err = newStrictDecoder(data).Decode(&dst.DocumentSshConfigTrait)
	if err == nil {
		jsonDocumentSshConfigTrait, _ := json.Marshal(dst.DocumentSshConfigTrait)
		if string(jsonDocumentSshConfigTrait) == "{}" { // empty struct
			dst.DocumentSshConfigTrait = nil
		} else {
			match++
		}
	} else {
		dst.DocumentSshConfigTrait = nil
	}

	if match > 1 { // more than 1 match
		// reset to nil
		dst.DocumentSshConfigTrait = nil

		return fmt.Errorf("data matches more than one schema in oneOf(MysqlTraitSshConfig)")
	} else if match == 1 {
		return nil // exactly one match
	} else { // no match
		return fmt.Errorf("data failed to match schemas in oneOf(MysqlTraitSshConfig)")
	}
}

// Marshal data from the first non-nil pointers in the struct to JSON
func (src MysqlTraitSshConfig) MarshalJSON() ([]byte, error) {
	if src.DocumentSshConfigTrait != nil {
		return json.Marshal(&src.DocumentSshConfigTrait)
	}

	return nil, nil // no data in oneOf schemas
}

// Get the actual instance
func (obj *MysqlTraitSshConfig) GetActualInstance() interface{} {
	if obj == nil {
		return nil
	}
	if obj.DocumentSshConfigTrait != nil {
		return obj.DocumentSshConfigTrait
	}

	// all schemas are nil
	return nil
}

type NullableMysqlTraitSshConfig struct {
	value *MysqlTraitSshConfig
	isSet bool
}

func (v NullableMysqlTraitSshConfig) Get() *MysqlTraitSshConfig {
	return v.value
}

func (v *NullableMysqlTraitSshConfig) Set(val *MysqlTraitSshConfig) {
	v.value = val
	v.isSet = true
}

func (v NullableMysqlTraitSshConfig) IsSet() bool {
	return v.isSet
}

func (v *NullableMysqlTraitSshConfig) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMysqlTraitSshConfig(val *MysqlTraitSshConfig) *NullableMysqlTraitSshConfig {
	return &NullableMysqlTraitSshConfig{value: val, isSet: true}
}

func (v NullableMysqlTraitSshConfig) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMysqlTraitSshConfig) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
